///////////////////////////////////
//  cWRg[ adconv.c  //
//  2010/05/14 PIC16F88  MikroC  //
///////////////////////////////////

#include "global.h"

static uchar ad_cnt;    //A/Dϊ
static int buff;        //A/Dϊobt@
int ad_res;             //A/Dϊ

void ad_init(void){
    ANSEL = 0x1;        //CH0
    ADCON0 = 0x41;      //FOSC/16,CH0,ADgp
    ADCON1 = 0xc0;      //El߁ACLK1/2,No_Vref
    ad_cnt = 0;
    buff = 0;
    timer_start(TIMER_AD, 10);  //10mSɂPA/D
}

void ad_conv(void){
    ADDATA addata;
    if(!timer_check_start(TIMER_AD)) return;
    ADCON0.GO = 1;
    while(ADCON0.GO);
    addata.adb[0] = ADRESL;
    addata.adb[1] = ADRESH;
    buff += addata.adw;
    ad_cnt++;
    if(ad_cnt == 16){           //16̕
        ad_res = buff >> 4;     //1/16
        buff = 0;
        ad_cnt = 0;
    }
}
