////////////////////////////////////
//  cWRg[  global.h  //
//  2010/05/17  PIC16F88  MikroC  //
////////////////////////////////////

#ifndef _GLOBAL_H
#define _GLOBAL_H

///// ^̒Zk
typedef unsigned char   uchar;
typedef unsigned int    uint;
typedef unsigned long   ulong;

///// main
extern uchar startF;
extern uchar startB;
extern uchar set_time;


///// Timer
#define TIMER_NUM           8
#define TIMER_INP           0
#define TIMER_PERIOD        1
#define TIMER_OUT           2
#define TIMER_LED_BLINK     3
#define TIMER_END           4
#define TIMER_AD            5
extern volatile uchar minute;
extern volatile uint m_tics;
extern void timer_init(void);
extern void timer_start(int, uint);
extern void timer_restart(int, uint);
extern void timer_cancel(int);
extern int timer_check(int);
extern int timer_check_start(int);

///// Output
extern void out_init(void);
extern void sequence(void);
extern void output(void);

///// A/d
typedef union{
    int adw;
    char adb[2];
}ADDATA;
extern ADDATA addata;
extern int ad_res;
extern void ad_init(void);
extern void ad_conv(void);

#endif